jif.extension

## Class JifBlockExt

- java.lang.Object
- - polyglot.ast.Ext_c
  - - jif.ast.JifExt_c
    - - jif.extension.JifStmtExt_c
      - - jif.extension.JifBlockExt

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, JifExt, JifStmtExt, polyglot.ast.Ext, polyglot.ast.NodeOps, polyglot.util.Copy<polyglot.ast.Ext>

      public class JifBlockExt
      extends JifStmtExt_c

  The Jif extension of the `Block` node.
  See Also:
    `Block_c`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface polyglot.util.Copy

      `polyglot.util.Copy.Util`

  - ### Field Summary

    - ### Fields inherited from class jif.extension.JifStmtExt_c

      `stmtDel`

    - ### Fields inherited from class jif.ast.JifExt_c

      `toJava, X`

    - ### Fields inherited from class polyglot.ast.Ext_c

      `ext, node, pred`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JifBlockExt(ToJavaExt toJava)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `polyglot.ast.Node` | `labelCheckStmt(LabelChecker lc)`
    `protected void` | `updateContextForNextStmt(LabelChecker lc, JifContext A, PathMap Xprev)` Utility method for updating the context for checking the next statement in the block.

    - ### Methods inherited from class jif.extension.JifStmtExt_c

      `copy, init, labelCheck, stmtDel, stmtDel`

    - ### Methods inherited from class jif.ast.JifExt_c

      `checkAndRemoveThrowType, checkThrowTypes, dump, getPathMap, integerBoundsCalculated, toJava, toJava, updatePathMap, X, X`

    - ### Methods inherited from class polyglot.ast.Ext_c

      `addDecls, buildTypes, buildTypesEnter, checkConstants, childExpectedType, copy, copy, disambiguate, disambiguateEnter, disambiguateOverride, dump, dump, dump, dump, enterChildScope, enterScope, exceptionCheck, exceptionCheckEnter, ext, ext, extRewrite, extRewriteEnter, extRewriteOverride, initPred, lang, node, pred, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrint, print, printBlock, printSubStmt, superLang, throwTypes, toString, translate, typeCheck, typeCheckEnter, typeCheckOverride, visitChild, visitChildren, visitList`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jif.ast.JifExt

      `integerBoundsCalculated, toJava, toJava, X, X`

    - ### Methods inherited from interface polyglot.ast.Ext

      `dump, ext, ext, initPred, node, pred`

    - ### Methods inherited from interface polyglot.ast.NodeOps

      `addDecls, buildTypes, buildTypesEnter, checkConstants, childExpectedType, copy, copy, disambiguate, disambiguateEnter, disambiguateOverride, dump, dump, dump, dump, enterChildScope, enterScope, exceptionCheck, exceptionCheckEnter, extRewrite, extRewriteEnter, extRewriteOverride, lang, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrint, throwTypes, translate, typeCheck, typeCheckEnter, typeCheckOverride, visitChild, visitChildren, visitList`

- - ### Constructor Detail

    - #### JifBlockExt

          public JifBlockExt(ToJavaExt toJava)

  - ### Method Detail

    - #### labelCheckStmt

          public polyglot.ast.Node labelCheckStmt(LabelChecker lc)
                                           throws polyglot.types.SemanticException

      Specified by:
        `labelCheckStmt` in interface `JifStmtExt`
      Specified by:
        `labelCheckStmt` in class `JifStmtExt_c`
      Throws:
        `polyglot.types.SemanticException`

    - #### updateContextForNextStmt

          protected void updateContextForNextStmt(LabelChecker lc,
                                                  JifContext A,
                                                  PathMap Xprev)

      Utility method for updating the context for checking the next statement in the block. Useful for overriding in projects like fabric.